#define WIN32_LEAN_AND_MEAN
#include<windows.h>
#include<tchar.h>
#include<d3d9.h>

#pragma comment(linker, "/SUBSYSTEM:WINDOWS")
#pragma comment(linker, "/ENTRY:DllMain")
#pragma comment(linker, "/MERGE:.rdata=.text")

#define __DBGMSG(text) OutputDebugString(_TEXT(text))

CRITICAL_SECTION cs; // Just in case
HINSTANCE hpixo = 0;

typedef void* (__stdcall *pfnDirect3DCreate8)(UINT);

void* __stdcall Direct3DCreate8(UINT version)
{
	EnterCriticalSection(&cs);

	__DBGMSG("Direct3DCreate8 called");

	hpixo = LoadLibrary(TEXT("dx9pixo.dll"));

	if (!hpixo)
	{
		__DBGMSG("Failed to load pixomatic");
		LeaveCriticalSection(&cs);
		return 0;
	}

	pfnDirect3DCreate8 pfn = (pfnDirect3DCreate8)GetProcAddress(hpixo, "_PixoDirect3DCreate8@4");
   
	if (!pfn)
	{
		__DBGMSG("Failed import function");
		LeaveCriticalSection(&cs);
		return 0;
	}

	void* ptr = pfn(version);

	LeaveCriticalSection(&cs);

	if (!ptr)
		__DBGMSG("Failed to create d3d8");
	else
		__DBGMSG("D3d8 created");

	return ptr;
}

BOOL APIENTRY DllMain(HANDLE hmodule, DWORD reason, LPVOID )
{
	switch (reason)
	{
	case DLL_PROCESS_ATTACH:
		DisableThreadLibraryCalls((HMODULE)hmodule);
		InitializeCriticalSection(&cs);
		break;

	case DLL_PROCESS_DETACH:
		DeleteCriticalSection(&cs);
		break;
	}

	return TRUE;
}